#include <opencv2/core/core.hpp>
#include <opencv2/imgproc/imgproc.hpp>
#include <opencv2/highgui/highgui.hpp>
#include <iostream>
#include <string>
using namespace cv;
using namespace std;

Mat back_ground,fram_now,dst_img_gray;
VideoCapture cap;

void fresh_fram(void);
int main(int argc, char *argv[])
{
    Mat back_tmp1,back_tmp2;
    cap.open(0);
    cap >> back_tmp1;
    if(!back_tmp1.data)
        {
            cout<<"Can't open camer"<<endl;
            return -1;
        }

    for(int i=0;i<10;i++){
        cap>>back_tmp2;
        addWeighted(back_tmp1,0.5,back_tmp2,0.5,0,back_ground);
        back_tmp1=back_ground;
    }//걳
    while(1)
    {
     fresh_fram();//֡֡
    char c= waitKey(50);
    if(c=='q')
    {
        break;
    }
    }


}

void fresh_fram(void)
{
    Mat back_ground_tmp=back_ground;
    cap >> fram_now;
    Mat fram_now_blur;
    blur(fram_now,fram_now_blur,Size(6,6));
    fram_now=fram_now_blur;

    Mat fram_gray,back_ground_gray;
    cvtColor(fram_now,fram_gray,CV_BGR2GRAY);
    cvtColor(back_ground_tmp,back_ground_gray,CV_BGR2GRAY);
    Mat dst_img_tmp;
    absdiff(fram_gray,back_ground_gray,dst_img_tmp);
    threshold(dst_img_tmp,dst_img_gray,10,255,THRESH_BINARY_INV);

    vector<vector <Point> > contours;
    findContours(dst_img_gray,contours,CV_RETR_EXTERNAL,CV_CHAIN_APPROX_NONE);
    Mat resulte=fram_now.clone();
    drawContours(resulte,contours,-1,Scalar(255,128,0),4,8);
    namedWindow("ͼ",CV_WINDOW_AUTOSIZE);
    imshow("ͼ",resulte);

    long long  x=0;
    long long y=0;
    int i=0,j=0;
    int count_num=0;
    for(i=0;i<dst_img_gray.rows;i++)
    {
        uchar *data=dst_img_gray.ptr<uchar>(i);
        for(j=0;j<dst_img_gray.cols;j++)
        {

            if(data[j]<1)
            {
                y+=i;
                x+=j;
                count_num+=1;
            }
        }
    }
    if(count_num!=0){
        x=x/count_num;
        y=y/count_num;
        cout<<"x: "<<x<<"y: "<<y<<endl;
    }

    namedWindow("֡ͼ",CV_WINDOW_AUTOSIZE);
    imshow("֡ͼ",dst_img_gray);
    Mat show_img;
    show_img=fram_now_blur.clone();
    ellipse(show_img,Point(x,y),Size(100,100),1,0,360,Scalar(255,129,0),2,8);
    namedWindow("blur",CV_WINDOW_AUTOSIZE);
    imshow("blur",show_img);

     x=0,y=0,count_num=0;
    addWeighted(fram_now,0.7,back_ground_tmp,0.3,0,back_ground);

}

